'捩り解析計算の実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class Tors2DCal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(160, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(160, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "捩り解析計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 184)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(144, 24)
        Me.PictureBox1.TabIndex = 6
        Me.PictureBox1.TabStop = False
        '
        'Tors2DCal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.PictureBox1, Me.ProgressBar1, Me.Label3, Me.Label2, Me.Label1})
        Me.Name = "Tors2DCal3"
        Me.Text = "Tors2DCal3"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim SwK As IO.StreamWriter      '結果出力用

    Dim Ktau As Integer             '最大剪断応力の節点番号
    Dim Mband As Integer            'FEM行列のﾊﾞﾝﾄﾞ幅（ﾊｰﾌ）
    Dim Nsurf As Integer            '境界辺の数

    Dim Area As Single              '断面積
    Dim Csx As Single               'X方向剪断係数
    Dim Csy As Single               'Y方向剪断係数
    Dim RIx As Single               '重心点でのX軸回りの断面2次ﾓｰﾒﾝﾄ
    Dim RIy As Single               '重心点でのY軸回りの断面2次ﾓｰﾒﾝﾄ
    Dim RK As Single                'ｻﾝﾌﾞﾅﾝの捩り定数
    Dim Rrev As Single              '回転半径
    Dim XGS As Single               '重心のX座標
    Dim YGS As Single               '重心のY座標
    Dim Zp As Single                '捩り断面係数

    Dim Kmulti(,) As Integer        '重複辺の区分変数
    Dim KPsurf(,) As Integer        '境界辺の３節点番号
    Dim KStMax(3) As Integer        '最大応力の節点番号
    Dim NNbendx(2) As Integer       'X軸回り曲げ断面係数の対称節点番号
    Dim NNbendy(2) As Integer       'Y軸回り曲げ断面係数の対称節点番号

    Dim Ds(8), Dt(8) As Single      '形状関数のs偏微分、t偏微分
    Dim Dx(8), Dy(8) As Single      '形状関数のx偏微分、y偏微分
    Dim Ef(8) As Single             '要素の右辺ﾍﾞｸﾄﾙ
    Dim Ek(,) As Single             '要素計算の２次配列
    Dim PosGaus(3) As Single        '積分点の位置
    Dim Shape(8) As Single          '形状関数
    Dim StMax(3) As Single          '最大応力
    Dim Tau() As Single             '節点のτ
    Dim TauX() As Single            '節点のτx
    Dim TauY() As Single            '節点のτy
    Dim Tf() As Single              'FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tk(,) As Single             '線形方程式の係数（右辺を含む）
    Dim Ua() As Single              '解の一次記憶ﾍﾞｸﾄﾙ
    Dim WeightG(3) As Single        '積分点の重み
    Dim XG(9), YG(9) As Single      'ｶﾞｳｽ点の座標
    Dim YIx(2) As Single            'X軸回り曲げ断面係数の対象点のY距離
    Dim XIy(2) As Single            'Y軸回り曲げ断面係数の対象点のX距離
    Dim Zbendx(2) As Single         'X軸回り曲げ断面係数
    Dim Zbendy(2) As Single         'Y軸回り曲げ断面係数

    Private Sub CalcExe1()
        '面積・重心・断面2次ﾓｰﾒﾝﾄ・曲げ断面係数・回転半径の計算
        Dim i, icount, ie As Integer
        Dim rmomentx, rmomenty, vinert As Single

        icount = 0
        Area = 0
        rmomentx = 0 : rmomenty = 0
        For ie = 1 To Nelem
            Call ElemCalc(ie, rmomentx, rmomenty)   '四角形要素の計算
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie
        XGS = rmomenty / Area
        YGS = rmomentx / Area

        RIx = 0 : RIy = 0
        vinert = 0
        For i = 1 To 2
            YIx(i) = 0
            XIy(i) = 0
        Next i
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemCalc2(ie, vinert)  '四角形要素の計算2
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        Zbendx(1) = RIx / (-YIx(1))
        Zbendx(2) = RIx / YIx(2)
        Zbendy(1) = RIy / (-XIy(1))
        Zbendy(2) = RIy / XIy(2)

        Rrev = Math.Sqrt(vinert / Area)

    End Sub

    Private Sub CalcExe2()
        '捩り定数の計算
        Dim i1, i2, ic, icount, ie, ii, j, j1, j2, jb, jj, k, kb, kk, num As Integer
        ReDim Kmulti(Nelem, 4)  '重複辺の区分変数

        For ie = 1 To Nelem - 1
            k = 0
            For j = 1 To 7 Step 2
                k = k + 1
                i1 = NNelem(ie, j)
                jb = j + 2
                If jb > 8 Then
                    jb = 1
                End If
                i2 = NNelem(ie, jb)
                For ii = ie + 1 To Nelem
                    kk = 0
                    For jj = 1 To 7 Step 2
                        kk = kk + 1
                        j1 = NNelem(ii, jj)
                        jb = jj + 2
                        If jb > 8 Then
                            jb = 1
                        End If
                        j2 = NNelem(ii, jb)
                        Call NumCheck(ic, i1, i2, j1, j2)   '要素辺の重なりﾁｪｯｸ
                        If ic = 1 Then
                            Kmulti(ie, k) = 1
                            Kmulti(ii, kk) = 1
                        End If
                    Next jj
                Next ii
            Next j
        Next ie

        Nsurf = 0
        For ie = 1 To Nelem
            For k = 1 To 4
                If Kmulti(ie, k) = 0 Then
                    Nsurf = Nsurf + 1
                End If
            Next k
        Next ie
        ReDim KPsurf(Nsurf, 3)

        num = 0
        For ie = 1 To Nelem
            For k = 1 To 4
                If Kmulti(ie, k) = 0 Then
                    num = num + 1
                    kb = 2 * k - 1
                    KPsurf(num, 1) = NNelem(ie, kb)
                    KPsurf(num, 2) = NNelem(ie, kb + 1)
                    If k < 4 Then
                        KPsurf(num, 3) = NNelem(ie, kb + 2)
                    Else
                        KPsurf(num, 3) = NNelem(ie, 1)
                    End If
                End If
            Next k
        Next ie

        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie)     '要素ﾏﾄﾘｯｸｽの計算
            Call Store(0)           '全体ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        Call HLoadSet() '境界辺の処理

        Application.DoEvents()
        Call Solver1(Mband)    'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）

        Tf(Nall) = Tf(Nall) / Tk(Nall, 1)

        Call Solver2(Mband)    'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        Application.DoEvents()

        icount = 0
        RK = 0
        For ie = 1 To Nelem
            Call ElemCalc3(ie)  '四角形要素の計算3
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

    End Sub

    Private Sub CalcExe3()
        '捩り応力の計算
        Dim icount, ie, ip, j, k, kg, nb As Integer
        Dim b1, b2, dj, s, t, taumax As Single
        Dim kbuf(Npoint) As Integer
        Dim buf(8) As Single
        ReDim Tau(Npoint), TauX(Npoint), TauY(Npoint)

        icount = 0
        For ie = 1 To Nelem
            For j = 1 To 8
                nb = NNelem(ie, j)
                XE(j) = X(nb) : YE(j) = Y(nb)
                buf(j) = Tf(Kcomp(nb))
            Next j
            For j = 1 To 8
                nb = NNelem(ie, j)
                Select Case j
                    Case 1
                        s = PosGaus(1) : t = PosGaus(1)
                    Case 2
                        s = 0 : t = PosGaus(1)
                    Case 3
                        s = PosGaus(3) : t = PosGaus(1)
                    Case 4
                        s = PosGaus(3) : t = 0
                    Case 5
                        s = PosGaus(3) : t = PosGaus(3)
                    Case 6
                        s = 0 : t = PosGaus(3)
                    Case 7
                        s = PosGaus(1) : t = PosGaus(3)
                    Case 8
                        s = PosGaus(1) : t = 0
                End Select
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                b1 = 0 : b2 = 0
                For k = 1 To 8
                    b1 = b1 + buf(k) * Dx(k)
                    b2 = b2 + buf(k) * Dy(k)
                Next k
                TauX(nb) = TauX(nb) + b1 - (YE(j) - YGS)
                TauY(nb) = TauY(nb) + b2 + XE(j) - XGS
                kbuf(nb) = kbuf(nb) + 1
            Next j
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie
        taumax = 0
        For ip = 1 To Npoint
            b1 = TauX(ip) / kbuf(ip)
            b2 = TauY(ip) / kbuf(ip)
            TauX(ip) = b1
            TauY(ip) = b2
            Tau(ip) = Math.Sqrt(b1 * b1 + b2 * b2)
            If Tau(ip) > taumax Then
                Ktau = ip
                taumax = Tau(ip)
            End If
        Next ip
        Zp = RK / taumax

    End Sub

    Private Sub CalcShear()
        '剪断係数の計算
        Dim icount, ie As Integer
        Dim amsx, amsy, rlsx, rlsy As Single

        Call NSecLength(rlsx, rlsy) '中立軸長さの計算

        icount = 0
        amsx = 0 : amsy = 0
        For ie = 1 To Nelem
            Call ElemShear(ie, amsx, amsy) '剪断係数の要素計算
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        If rlsx > 0 Then
            Csx = Area * amsx / (rlsx * RIy)
            If Csx < 1.1 Then
                Csx = 1.1
            End If
        Else
            Csx = -1
        End If
        If rlsy > 0 Then
            Csy = Area * amsy / (rlsy * RIx)
            If Csy < 1.1 Then
                Csy = 1.1
            End If
        Else
            Csy = -1
        End If

    End Sub

    Private Sub ElemCalc(ByVal ie As Integer, ByRef rmx As Single, _
        ByRef rmy As Single)
        '四角形要素の計算
        'ie･･･要素番号
        'rmx,rmy･･･x,y軸回り1次ﾓｰﾒﾝﾄ
        Dim i, ig, ii, jg, kg As Integer
        Dim da, dj, s, t As Single
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i) : YE(ii) = Y(i)
        Next ii

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                Area = Area + da
                rmx = rmx + da * YG(kg)
                rmy = rmy + da * XG(kg)
            Next jg
        Next ig

    End Sub

    Private Sub ElemCalc2(ByVal ie As Integer, ByRef vinert As Single)
        '四角形要素の計算2
        'ie･･･要素番号
        'vinert･･･極2次ﾓｰﾒﾝﾄ
        Dim i, ig, ii, jg, kg As Integer
        Dim b1, b2, b3, b4, da, dj, s, t As Single
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i) : YE(ii) = Y(i)
            b1 = XE(ii) - XGS
            b2 = YE(ii) - YGS
            If b2 < YIx(1) Then
                NNbendx(1) = i
                YIx(1) = b2
            ElseIf b2 > YIx(2) Then
                NNbendx(2) = i
                YIx(2) = b2
            End If
            If b1 < XIy(1) Then
                NNbendy(1) = i
                XIy(1) = b1
            ElseIf b1 > XIy(2) Then
                NNbendy(2) = i
                XIy(2) = b1
            End If
        Next ii

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                b1 = XG(kg) - XGS
                b2 = YG(kg) - YGS
                b3 = b1 * b1
                b4 = b2 * b2
                RIx = RIx + da * b4
                RIy = RIy + da * b3
                vinert = vinert + da * (b3 + b4)
            Next jg
        Next ig

    End Sub

    Private Sub ElemCalc3(ByVal ie As Integer)
        '四角形要素の計算3
        'ie･･･要素番号
        Dim i, ig, ii, jg, kg As Integer
        Dim b1, b2, b3, b4, da, dj, s, t As Single
        Dim wbuf(8) As Single
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i) : YE(ii) = Y(i)
            wbuf(ii) = Tf(Kcomp(i))
        Next ii

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                b1 = XG(kg) - XGS
                b2 = YG(kg) - YGS
                b3 = 0 : b4 = 0
                For ii = 1 To 8
                    b3 = b3 + Dx(ii) * wbuf(ii)
                    b4 = b4 + Dy(ii) * wbuf(ii)
                Next ii
                b3 = b3 - b2
                b4 = b4 + b1
                RK = RK + (b3 * b3 + b4 * b4) * da
            Next jg
        Next ig

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        Dim i, id, ig, ii, j, jg, k, kg As Integer
        Dim da, dj, s, t As Single
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i) : YE(ii) = Y(i)
        Next ii
        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
            Ef(i) = 0
        Next i

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                For i = 1 To Nvar
                    For j = i To Nvar
                        Ek(i, j) = Ek(i, j) + (Dx(i) * Dx(j) + Dy(i) * Dy(j)) * da
                    Next j
                    Ef(i) = Ef(i) + 2 * Shape(i) * da
                Next i
            Next jg
        Next ig

        j = 0
        For ii = 1 To 8
            i = NNelem(ie, ii)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = k
            Next id
        Next ii

    End Sub

    Private Sub ElemShear(ByVal ie As Integer, ByRef amsx As Single, _
    ByRef amsy As Single)
        '剪断係数の要素計算
        'ie･･･要素番号
        'arsx,arsy･･･x,y軸方向剪断に関する中立軸回り面積ﾓｰﾒﾝﾄ
        Dim i, ig, ii, jg, kg As Integer
        Dim da, dj, s, t As Single
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i) : YE(ii) = Y(i)
        Next ii

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                If XG(kg) < XGS Then
                    amsx = amsx + da * (XGS - XG(kg))
                End If
                If YG(kg) < YGS Then
                    amsy = amsy + da * (YGS - YG(kg))
                End If
            Next jg
        Next ig

    End Sub

    Private Sub HLoadSet()
        '境界辺の処理
        Dim i, ig, ii, j, jb, jj As Integer
        Dim b1, b2, b3, b4, xb, yb As Single
        For ii = 1 To Nsurf
            For jj = 1 To 3
                jb = KPsurf(ii, jj)
                XE(jj) = X(jb)
                YE(jj) = Y(jb)
            Next jj

            For ig = 1 To Ngaus
                Call SideJacob(ig, b1, b2, b3, xb, yb)  '辺のＪＡＣＯＢ
                For i = 1 To 3
                    j = Kcomp(KPsurf(ii, i))
                    b4 = Shape(i) * b3
                    Tf(j) = Tf(j) + ((xb - XGS) * b1 + (yb - YGS) * b2) * b4
                Next i
            Next ig
        Next ii
    End Sub

    Private Sub InitialSet1()
        '初期設定
        Ndim = 1
        Ngaus = 3
        Nvar = 8 : Nall = Ndim * Npoint

        ReDim NPrefer(Nvar), Ek(Nvar, Nvar)
        ReDim Tf(Nall)

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

    End Sub

    Private Sub JacobElem(ByVal ie As Integer, ByVal kg As Integer, _
        ByRef dj As Single)
        '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        Dim c1$, c2$
        Dim ii As Integer
        Dim b1, b2, b3, b4, b5, b6, b7, b8 As Single
        XG(kg) = 0 : YG(kg) = 0
        For ii = 1 To 8
            XG(kg) = XG(kg) + XE(ii) * Shape(ii)
            YG(kg) = YG(kg) + YE(ii) * Shape(ii)
        Next ii
        b1 = 0 : b2 = 0 : b3 = 0 : b4 = 0
        For ii = 1 To 8
            b1 = b1 + Ds(ii) * XE(ii)
            b2 = b2 + Ds(ii) * YE(ii)
            b3 = b3 + Dt(ii) * XE(ii)
            b4 = b4 + Dt(ii) * YE(ii)
        Next ii
        dj = b1 * b4 - b2 * b3
        If dj <= 0 Then
            c1$ = "計算実行エラー"
            c2$ = "要素" + LTrim$(Str$(ie)) + "（ガウス点" + LTrim$(Str$(kg))
            c2$ = c2$ + "）でヤコビアン面積が負か０になりました。"
            MsgBox(c2$, 0, c1$)
            End
        Else
            b5 = b4 / dj : b8 = b1 / dj
            b6 = -b2 / dj : b7 = -b3 / dj
            For ii = 1 To 8
                Dx(ii) = b5 * Ds(ii) + b6 * Dt(ii)
                Dy(ii) = b7 * Ds(ii) + b8 * Dt(ii)
            Next ii
        End If
    End Sub

    Private Sub NSecLength(ByRef rlsx As Single, ByRef rlsy As Single)
        '中立軸長さの計算
        'rlsx,rlsy･･･中立軸の切断長
        Dim i, j, k1, k2, nsx, nsy As Integer
        Dim b1, b2, b3, x1, x2, y1, y2 As Single
        Dim kbufsx(Npoint), kbufsy(Npoint) As Integer
        Dim xbufsy(40), ybufsx(40) As Single

        nsx = 0 : nsy = 0
        For i = 1 To Nsurf
            k1 = KPsurf(i, 1)
            x1 = X(k1)
            y1 = Y(k1)
            For j = 2 To 3
                k2 = KPsurf(i, j)
                x2 = X(k2)
                y2 = Y(k2)
                b1 = x1 - XGS
                b2 = x2 - XGS
                If b1 * b2 <= 0 Then
                    If b1 <> 0 And b2 <> 0 Then
                        nsx = nsx + 1
                        b1 = Math.Abs(b1)
                        b2 = Math.Abs(b2)
                        b3 = Math.Abs(x2 - x1)
                        ybufsx(nsx) = (b2 * y1 + b1 * y2) / b3
                    Else
                        If b1 = 0 And kbufsx(k1) = 0 Then
                            kbufsx(k1) = 1
                            nsx = nsx + 1
                            ybufsx(nsx) = y1
                        End If
                        If b2 = 0 And kbufsx(k2) = 0 Then
                            kbufsx(k2) = 1
                            nsx = nsx + 1
                            ybufsx(nsx) = y2
                        End If
                    End If
                End If
                b1 = y1 - YGS
                b2 = y2 - YGS
                If b1 * b2 <= 0 Then
                    If b1 <> 0 And b2 <> 0 Then
                        nsy = nsy + 1
                        b1 = Math.Abs(b1)
                        b2 = Math.Abs(b2)
                        b3 = Math.Abs(y2 - y1)
                        xbufsy(nsy) = (b2 * x1 + b1 * x2) / b3
                    Else
                        If b1 = 0 And kbufsy(k1) = 0 Then
                            kbufsy(k1) = 1
                            nsy = nsy + 1
                            xbufsy(nsy) = x1
                        End If
                        If b2 = 0 And kbufsy(k2) = 0 Then
                            kbufsy(k2) = 1
                            nsy = nsy + 1
                            xbufsy(nsy) = x2
                        End If
                    End If
                End If
                If j < 3 Then
                    k1 = k2
                    x1 = x2
                    y1 = y2
                End If
            Next j
        Next i

        Call Sorting(nsx, ybufsx) 'X方向剪断のｿｰﾃｨﾝｸﾞ
        Call SecLength(nsx, rlsx, ybufsx)   'X方向剪断の長さ計算
        b1 = 1.5 * Area / (XaxisMax - XaxisMin)
        If b1 < rlsx Then
            rlsx = b1
        End If

        Call Sorting(nsy, xbufsy) 'Y方向剪断のｿｰﾃｨﾝｸﾞ
        Call SecLength(nsy, rlsy, xbufsy)  'Y方向剪断の長さ計算
        b1 = 1.5 * Area / (YaxisMax - YaxisMin)
        If b1 < rlsy Then
            rlsy = b1
        End If

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        SwK.WriteLine("＜＜２次元捩り解析の計算結果＞＞")
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)

        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊＊ 計算結果 ＊＊＊")
        aa$ = "バンド幅" + "," + Str(Mband)
        SwK.WriteLine(aa$)
        SwK.WriteLine("----------------------------------------------")

    End Sub

    Private Sub ResFile2U()
        '結果ﾌｧｲﾙへの出力2
        'UTF-8･･･BOMなし
        Dim aa$
        Dim ip, k, nb As Integer
        Dim b1, z1 As Single
        Dim zbuf(3) As Single

        SwK.WriteLine("＊＊ 断面定数 ＊＊")
        aa$ = "重心位置のX、Y座標" + "," + Str(XGS) + "," + Str(YGS)
        SwK.WriteLine(aa$)
        aa$ = "断面積" + "," + Str(Area)
        SwK.WriteLine(aa$)
        aa$ = "重心原点X軸回り2次モーメント" + "," + Str(RIx)
        SwK.WriteLine(aa$)
        aa$ = "重心原点Y軸回り2次モーメント" + "," + Str(RIy)
        SwK.WriteLine(aa$)
        nb = NNbendx(1)
        b1 = YGS - Y(nb)
        z1 = RIx / b1
        aa$ = "X軸回り曲げ断面係数(X軸右側）" + "," + Str(z1)
        SwK.WriteLine(aa$)
        aa$ = "上記対象点のX、Y座標" + "," + Str(X(nb)) + "," + Str(Y(nb))
        SwK.WriteLine(aa$)
        nb = NNbendx(2)
        b1 = Y(nb) - YGS
        z1 = RIx / b1
        aa$ = "X軸回り曲げ断面係数(X軸左側）" + "," + Str(z1)
        SwK.WriteLine(aa$)
        aa$ = "上記対象点のX、Y座標" + "," + Str(X(nb)) + "," + Str(Y(nb))
        SwK.WriteLine(aa$)
        nb = NNbendy(2)
        b1 = X(nb) - XGS
        z1 = RIy / b1
        aa$ = "Y軸回り曲げ断面係数(Y軸右側）" + "," + Str(z1)
        SwK.WriteLine(aa$)
        aa$ = "上記対象点のX、Y座標" + "," + Str(X(nb)) + "," + Str(Y(nb))
        SwK.WriteLine(aa$)
        nb = NNbendy(1)
        b1 = XGS - X(nb)
        z1 = RIy / b1
        aa$ = "Y軸回り曲げ断面係数(Y軸左側）" + "," + Str(z1)
        SwK.WriteLine(aa$)
        aa$ = "上記対象点のX、Y座標" + "," + Str(X(nb)) + "," + Str(Y(nb))
        SwK.WriteLine(aa$)
        If Csx > 0 Then
            aa$ = "X軸方向剪断係数" + "," + Str(Csx)
            SwK.WriteLine(aa$)
        Else
            aa$ = "X軸方向剪断係数" + "," + "Error"
            SwK.WriteLine(aa$)
        End If
        If Csy > 0 Then
            aa$ = "Y軸方向剪断係数" + "," + Str(Csy)
            SwK.WriteLine(aa$)
        Else
            aa$ = "Y軸方向剪断係数" + "," + "Error"
        End If
        aa$ = "回転半径" + "," + Str(Rrev)
        SwK.WriteLine(aa$)
        aa$ = "サンブナンの捩り定数" + "," + Str(RK)
        SwK.WriteLine(aa$)
        aa$ = "捩り断面係数" + ", " + Str(Zp)
        SwK.WriteLine(aa$)
        aa$ = "上記対象点のX、Y座標" + "," + Str(X(Ktau)) + "," + Str(Y(Ktau))
        SwK.WriteLine(aa$)

        SwK.WriteLine("----------------------------------------------")
        z1 = (180 / Pai) * TMoment / (Gshear * RK)
        aa$ = "軸の単位長さ当たりの捩れ角（°）" + "," + Str(z1)
        SwK.WriteLine(aa$)
        SwK.WriteLine("＊＊ 剪断応力 ＊＊")
        SwK.WriteLine("＜節点番号、τx、τy、τmax＞")
        b1 = TMoment / RK
        For ip = 1 To Npoint
            aa$ = Str$(ip)
            zbuf(1) = b1 * TauX(ip)
            zbuf(2) = b1 * TauY(ip)
            zbuf(3) = b1 * Tau(ip)
            For k = 1 To 3
                aa$ = aa$ + ",  " + Str$(zbuf(k))
                If Math.Abs(zbuf(k)) > Math.Abs(StMax(k)) Then
                    StMax(k) = zbuf(k)
                    KStMax(k) = ip
                End If
            Next k
            SwK.WriteLine(aa$)
        Next ip

    End Sub

    Private Sub ResFile3U()
        '結果ﾌｧｲﾙへの出力3
        'UTF-8･･･BOMなし
        Dim aa$, ad$
        Dim i As Integer
        Dim abuf$(3)

        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、  最大値、        節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        abuf$(1) = "τx"
        abuf$(2) = "τy"
        abuf$(3) = "τmax"
        For i = 1 To 3
            aa$ = abuf$(i) + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(StMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KStMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub SecLength(ByVal nb As Integer, ByRef rls As Single, _
    ByVal buf1() As Single)
        '剪断の長さ計算
        'nb･･･点の数
        'rls･･･剪断の長さ（負はｴﾗｰ）
        'buf1()･･･第1座標
        Dim i, k As Integer

        rls = 0
        k = nb Mod 2
        If k = 0 Then
            For i = 1 To nb - 1 Step 2
                rls = rls + (buf1(i + 1) - buf1(i))
            Next i
        Else
            rls = -1
        End If

    End Sub

    Private Sub ShapeFunc(ByVal s As Single, ByVal t As Single)
        '形状関数の計算
        's･･･要素のξ座標
        't･･･要素のη座標
        Dim b1, b2, b3, s2, ss, st, t2, tt As Single
        s2 = s * 2 : t2 = t * 2
        ss = s * s : tt = t * t : st = s * t
        b1 = ss * t : b2 = s * tt : b3 = st * 2
        Shape(1) = (-1 + st + ss + tt - b1 - b2) / 4
        Shape(2) = (1 - t - ss + b1) / 2
        Shape(3) = (-1 - st + ss + tt - b1 + b2) / 4
        Shape(4) = (1 + s - tt - b2) / 2
        Shape(5) = (-1 + st + ss + tt + b1 + b2) / 4
        Shape(6) = (1 + t - ss - b1) / 2
        Shape(7) = (-1 - st + ss + tt + b1 - b2) / 4
        Shape(8) = (1 - s - tt + b2) / 2
        Ds(1) = (t + s2 - b3 - tt) / 4
        Ds(2) = -s + st
        Ds(3) = (-t + s2 - b3 + tt) / 4
        Ds(4) = (1 - tt) / 2
        Ds(5) = (t + s2 + b3 + tt) / 4
        Ds(6) = -s - st
        Ds(7) = (-t + s2 + b3 - tt) / 4
        Ds(8) = (-1 + tt) / 2
        Dt(1) = (s + t2 - ss - b3) / 4
        Dt(2) = (-1 + ss) / 2
        Dt(3) = (-s + t2 - ss + b3) / 4
        Dt(4) = -t - st
        Dt(5) = (s + t2 + ss + b3) / 4
        Dt(6) = (1 - ss) / 2
        Dt(7) = (-s + t2 + ss - b3) / 4
        Dt(8) = -t + st
    End Sub

    Private Sub SideJacob(ByVal ig As Integer, ByRef b1 As Single, _
        ByRef b2 As Single, ByRef b3 As Single, _
        ByRef xb As Single, ByRef yb As Single)
        '辺のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽ成分の計算
        'ig･･･ｶﾞｳｽ点番号
        'b1･･･X座標のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽ
        'b2･･･Y座標のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽ
        'b3･･･積分係数
        'xb,yb･･･積分位置の座標
        Dim i As Integer
        Dim s, s2, ss As Single
        s = PosGaus(ig)
        s2 = s * 2 : ss = s * s
        Shape(1) = (-s + ss) / 2
        Shape(2) = 1 - ss
        Shape(3) = (s + ss) / 2
        Ds(1) = (-1 + s2) / 2
        Ds(2) = -s2
        Ds(3) = (1 + s2) / 2
        xb = 0 : yb = 0 : b1 = 0 : b2 = 0
        For i = 1 To 3
            xb = xb + XE(i) * Shape(i)
            yb = yb + YE(i) * Shape(i)
            b1 = b1 + Ds(i) * XE(i)
            b2 = b2 + Ds(i) * YE(i)
        Next i
        '    dj = Math.Sqrt(b1 ^ 2 + b2 ^ 2)
        b3 = WeightG(ig)

    End Sub

    Private Sub Sorting(ByVal nb As Integer, ByRef buf1() As Single)
        'ｿｰﾃｨﾝｸﾞ
        'nb･･･座標の数
        'buf1()･･･第1座標
        Dim i, j As Integer
        Dim b1 As Single

        For i = 1 To nb - 1
            For j = i + 1 To nb
                If buf1(j) < buf1(i) Then
                    b1 = buf1(i)
                    buf1(i) = buf1(j)
                    buf1(j) = b1
                End If
            Next j
        Next i

    End Sub

    Private Sub Solver1(ByVal mb As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, icount, it, jt, j, k, mx As Integer
        Dim b1 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        icount = 0
        For k = 1 To Nall - 1
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            b1 = Tk(k, 1)
            For j = 2 To mx
                Ua(j) = Tk(k, j) / b1
            Next j
            Tf(k) = Tf(k) / b1
            For i = 2 To mx
                b1 = Tk(k, i)
                If b1 <> 0 Then
                    it = i + k - 1
                    For j = i To mx
                        If Ua(j) <> 0 Then
                            jt = j - i + 1
                            Tk(it, jt) = Tk(it, jt) - b1 * Ua(j)
                        End If
                    Next j
                    Tf(it) = Tf(it) - b1 * Tf(k)
                End If
            Next i
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mb As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim j, jt, k, mx As Integer
        Dim s As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)
        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        For k = Nall - 1 To 1 Step -1
            s = 0 : mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                s = s + Tk(k, j) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s / Tk(k, 1)
        Next k

        gr.Dispose()

    End Sub

    Private Sub Store(ByVal kind As Integer)
        '全体ﾏﾄﾘｯｸｽへの蓄積
        'kind･･･右辺の有無（0:なし、1:有り）
        Dim i, ib, it, j, jt As Integer
        For i = 1 To Nvar
            For j = i To Nvar
                it = NPrefer(i) : jt = NPrefer(j)
                If it > jt Then
                    ib = it
                    it = jt
                    jt = ib
                End If
                Tk(it, jt - it + 1) = Tk(it, jt - it + 1) + Ek(i, j)
            Next j
            If kind > 0 Then
                it = NPrefer(i)
                Tf(it) = Tf(it) + Ef(i)
            End If
        Next i
    End Sub

    Private Sub Tors2DCal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, mbx As Integer
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        Me.Show()

        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf)   '座標値の端数処理
        ReDim Kcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(Mband, mbx, xbuf, ybuf)  '節点順序の改良

        Call InitialSet1()  '初期設定

        ReDim Tk(Nall, Mband), Ua(Mband)

        Call ResFile1U() '結果ﾌｧｲﾙへの出力1
        Application.DoEvents()

        Call CalcExe1() '面積・重心・断面2次ﾓｰﾒﾝﾄ・曲げ断面係数・回転半径の計算
        Application.DoEvents()

        '進行表示
        ProgressBar1.Value = 20

        Call CalcExe2() '捩り定数の計算
        Application.DoEvents()

        ProgressBar1.Value = 40

        Call CalcExe3() '捩り応力の計算
        Application.DoEvents()

        Call CalcShear()    '剪断係数の計算
        Application.DoEvents()

        Call ResFile2U() '結果ﾌｧｲﾙへの出力2
        Call ResFile3U() '結果ﾌｧｲﾙへの出力3
        Application.DoEvents()

        '進行表示
        ProgressBar1.Value = 100
        gr.Clear(Color.White)

        Call TimCal(1, timn$)
        aa$ = "END   " & timn$
        SwK.WriteLine(aa$)
        SwK.Close()

        Label1.Text = "計算終了！"
        Label2.Text = "計算結果をファイルへ出力しました。"
        Label3.Text = aa$
        aa$ = "計算が終了しました。"
        Me.BringToFront()
        aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
        MsgBox(aa$, 0, "計算確認")

        gr.Dispose()

        Me.Close()

    End Sub
End Class
